"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.SaltLength = exports.PEMCipher = exports.Hash = void 0;
var _reactNative = require("react-native");
var flatbuffers = _interopRequireWildcard(require("flatbuffers"));
var _boolResponse = require("./model/bool-response");
var _generateRequest = require("./model/generate-request");
var _keyPairResponse = require("./model/key-pair-response");
var _stringResponse = require("./model/string-response");
var _convertPrivateKeyRequest = require("./model/convert-private-key-request");
var _convertJwtrequest = require("./model/convert-jwtrequest");
var _convertKeyPairRequest = require("./model/convert-key-pair-request");
var _convertPkcs12Request = require("./model/convert-pkcs12-request");
var _convertPublicKeyRequest = require("./model/convert-public-key-request");
var _decryptPrivateKeyRequest = require("./model/decrypt-private-key-request");
var _encryptPrivateKeyRequest = require("./model/encrypt-private-key-request");
var _decryptOaeprequest = require("./model/decrypt-oaeprequest");
var _decryptPkcs1v15Request = require("./model/decrypt-pkcs1v15-request");
var _encryptOaeprequest = require("./model/encrypt-oaeprequest");
var _encryptPkcs1v15Request = require("./model/encrypt-pkcs1v15-request");
var _signPssrequest = require("./model/sign-pssrequest");
var _signPkcs1v15Request = require("./model/sign-pkcs1v15-request");
var _verifyPssrequest = require("./model/verify-pssrequest");
var _verifyPkcs1v15Request = require("./model/verify-pkcs1v15-request");
var _hashRequest = require("./model/hash-request");
var _base64Request = require("./model/base64-request");
var _pkcs12KeyPairResponse = require("./model/pkcs12-key-pair-response");
var _bytesResponse = require("./model/bytes-response");
require("./shim");
var _decryptOaepbytesRequest = require("./model/decrypt-oaepbytes-request");
var _decryptPkcs1v15BytesRequest = require("./model/decrypt-pkcs1v15-bytes-request");
var _encryptOaepbytesRequest = require("./model/encrypt-oaepbytes-request");
var _encryptPkcs1v15BytesRequest = require("./model/encrypt-pkcs1v15-bytes-request");
var _signPssbytesRequest = require("./model/sign-pssbytes-request");
var _signPkcs1v15BytesRequest = require("./model/sign-pkcs1v15-bytes-request");
var _verifyPssbytesRequest = require("./model/verify-pssbytes-request");
var _verifyPkcs1v15BytesRequest = require("./model/verify-pkcs1v15-bytes-request");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const FastRSANativeModules = _reactNative.NativeModules.FastRsa;
const isDebuggingEnabled = typeof atob !== 'undefined' && typeof HermesInternal === 'undefined';
typeof global.FastRSACallPromise === 'undefined' && !isDebuggingEnabled && FastRSANativeModules.install();
let Hash = exports.Hash = /*#__PURE__*/function (Hash) {
  Hash[Hash["MD5"] = 0] = "MD5";
  Hash[Hash["SHA1"] = 1] = "SHA1";
  Hash[Hash["SHA224"] = 2] = "SHA224";
  Hash[Hash["SHA256"] = 3] = "SHA256";
  Hash[Hash["SHA384"] = 4] = "SHA384";
  Hash[Hash["SHA512"] = 5] = "SHA512";
  return Hash;
}({});
let PEMCipher = exports.PEMCipher = /*#__PURE__*/function (PEMCipher) {
  PEMCipher[PEMCipher["DES"] = 0] = "DES";
  PEMCipher[PEMCipher["D3DES"] = 1] = "D3DES";
  PEMCipher[PEMCipher["AES128"] = 2] = "AES128";
  PEMCipher[PEMCipher["AES192"] = 3] = "AES192";
  PEMCipher[PEMCipher["AES256"] = 4] = "AES256";
  return PEMCipher;
}({});
let SaltLength = exports.SaltLength = /*#__PURE__*/function (SaltLength) {
  SaltLength[SaltLength["AUTO"] = 0] = "AUTO";
  SaltLength[SaltLength["EQUALS_HASH"] = 1] = "EQUALS_HASH";
  return SaltLength;
}({});
class RSAError extends Error {
  constructor(message) {
    super(message);
    this.name = 'RSAError';
  }
}
class RSA {
  static useJSI = true;
  static async convertJWKToPrivateKey(data, keyId) {
    const builder = new flatbuffers.Builder(0);
    const dataOffset = builder.createString(JSON.stringify(data));
    const keyIdOffset = builder.createString(keyId);
    _convertJwtrequest.ConvertJWTRequest.startConvertJWTRequest(builder);
    _convertJwtrequest.ConvertJWTRequest.addData(builder, dataOffset);
    _convertJwtrequest.ConvertJWTRequest.addKeyId(builder, keyIdOffset);
    const offset = _convertJwtrequest.ConvertJWTRequest.endConvertJWTRequest(builder);
    builder.finish(offset);
    const result = await this.call('convertJWKToPrivateKey', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async convertJWKToPublicKey(data, keyId) {
    const builder = new flatbuffers.Builder(0);
    const dataOffset = builder.createString(JSON.stringify(data));
    const keyIdOffset = builder.createString(keyId);
    _convertJwtrequest.ConvertJWTRequest.startConvertJWTRequest(builder);
    _convertJwtrequest.ConvertJWTRequest.addData(builder, dataOffset);
    _convertJwtrequest.ConvertJWTRequest.addKeyId(builder, keyIdOffset);
    const offset = _convertJwtrequest.ConvertJWTRequest.endConvertJWTRequest(builder);
    builder.finish(offset);
    const result = await this.call('convertJWKToPublicKey', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async convertKeyPairToPKCS12(privateKey, certificate, password) {
    const builder = new flatbuffers.Builder(0);
    const privateKeyOffset = builder.createString(privateKey);
    const passwordOffset = builder.createString(password);
    const certificateOffset = builder.createString(certificate);
    _convertKeyPairRequest.ConvertKeyPairRequest.startConvertKeyPairRequest(builder);
    _convertKeyPairRequest.ConvertKeyPairRequest.addPrivateKey(builder, privateKeyOffset);
    _convertKeyPairRequest.ConvertKeyPairRequest.addCertificate(builder, certificateOffset);
    _convertKeyPairRequest.ConvertKeyPairRequest.addPassword(builder, passwordOffset);
    const offset = _convertKeyPairRequest.ConvertKeyPairRequest.endConvertKeyPairRequest(builder);
    builder.finish(offset);
    const result = await this.call('convertKeyPairToPKCS12', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async convertPKCS12ToKeyPair(pkcs12, password) {
    const builder = new flatbuffers.Builder(0);
    const pkcs12Offset = builder.createString(pkcs12);
    const passwordOffset = builder.createString(password);
    _convertPkcs12Request.ConvertPKCS12Request.startConvertPKCS12Request(builder);
    _convertPkcs12Request.ConvertPKCS12Request.addPkcs12(builder, pkcs12Offset);
    _convertPkcs12Request.ConvertPKCS12Request.addPassword(builder, passwordOffset);
    const offset = _convertPkcs12Request.ConvertPKCS12Request.endConvertPKCS12Request(builder);
    builder.finish(offset);
    const result = await this.call('convertPKCS12ToKeyPair', builder.asUint8Array());
    return this._pkcs12KeyPairResponse(result);
  }
  static async convertPrivateKeyToPKCS8(privateKey) {
    const builder = new flatbuffers.Builder(0);
    const privateKeyOffset = builder.createString(privateKey);
    _convertPrivateKeyRequest.ConvertPrivateKeyRequest.startConvertPrivateKeyRequest(builder);
    _convertPrivateKeyRequest.ConvertPrivateKeyRequest.addPrivateKey(builder, privateKeyOffset);
    const offset = _convertPrivateKeyRequest.ConvertPrivateKeyRequest.endConvertPrivateKeyRequest(builder);
    builder.finish(offset);
    const result = await this.call('convertPrivateKeyToPKCS8', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async convertPrivateKeyToPKCS1(privateKey) {
    const builder = new flatbuffers.Builder(0);
    const privateKeyOffset = builder.createString(privateKey);
    _convertPrivateKeyRequest.ConvertPrivateKeyRequest.startConvertPrivateKeyRequest(builder);
    _convertPrivateKeyRequest.ConvertPrivateKeyRequest.addPrivateKey(builder, privateKeyOffset);
    const offset = _convertPrivateKeyRequest.ConvertPrivateKeyRequest.endConvertPrivateKeyRequest(builder);
    builder.finish(offset);
    const result = await this.call('convertPrivateKeyToPKCS1', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async convertPrivateKeyToJWK(privateKey) {
    const builder = new flatbuffers.Builder(0);
    const privateKeyOffset = builder.createString(privateKey);
    _convertPrivateKeyRequest.ConvertPrivateKeyRequest.startConvertPrivateKeyRequest(builder);
    _convertPrivateKeyRequest.ConvertPrivateKeyRequest.addPrivateKey(builder, privateKeyOffset);
    const offset = _convertPrivateKeyRequest.ConvertPrivateKeyRequest.endConvertPrivateKeyRequest(builder);
    builder.finish(offset);
    const result = await this.call('convertPrivateKeyToJWK', builder.asUint8Array());
    return JSON.parse(this._stringResponse(result));
  }
  static async convertPrivateKeyToPublicKey(privateKey) {
    const builder = new flatbuffers.Builder(0);
    const privateKeyOffset = builder.createString(privateKey);
    _convertPrivateKeyRequest.ConvertPrivateKeyRequest.startConvertPrivateKeyRequest(builder);
    _convertPrivateKeyRequest.ConvertPrivateKeyRequest.addPrivateKey(builder, privateKeyOffset);
    const offset = _convertPrivateKeyRequest.ConvertPrivateKeyRequest.endConvertPrivateKeyRequest(builder);
    builder.finish(offset);
    const result = await this.call('convertPrivateKeyToPublicKey', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async convertPublicKeyToPKIX(publicKey) {
    const builder = new flatbuffers.Builder(0);
    const publicKeyOffset = builder.createString(publicKey);
    _convertPublicKeyRequest.ConvertPublicKeyRequest.startConvertPublicKeyRequest(builder);
    _convertPublicKeyRequest.ConvertPublicKeyRequest.addPublicKey(builder, publicKeyOffset);
    const offset = _convertPublicKeyRequest.ConvertPublicKeyRequest.endConvertPublicKeyRequest(builder);
    builder.finish(offset);
    const result = await this.call('convertPublicKeyToPKIX', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async convertPublicKeyToPKCS1(publicKey) {
    const builder = new flatbuffers.Builder(0);
    const publicKeyOffset = builder.createString(publicKey);
    _convertPublicKeyRequest.ConvertPublicKeyRequest.startConvertPublicKeyRequest(builder);
    _convertPublicKeyRequest.ConvertPublicKeyRequest.addPublicKey(builder, publicKeyOffset);
    const offset = _convertPublicKeyRequest.ConvertPublicKeyRequest.endConvertPublicKeyRequest(builder);
    builder.finish(offset);
    const result = await this.call('convertPublicKeyToPKCS1', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async convertPublicKeyToJWK(publicKey) {
    const builder = new flatbuffers.Builder(0);
    const publicKeyOffset = builder.createString(publicKey);
    _convertPublicKeyRequest.ConvertPublicKeyRequest.startConvertPublicKeyRequest(builder);
    _convertPublicKeyRequest.ConvertPublicKeyRequest.addPublicKey(builder, publicKeyOffset);
    const offset = _convertPublicKeyRequest.ConvertPublicKeyRequest.endConvertPublicKeyRequest(builder);
    builder.finish(offset);
    const result = await this.call('convertPublicKeyToJWK', builder.asUint8Array());
    return JSON.parse(this._stringResponse(result));
  }
  static async decryptPrivateKey(privateKeyEncrypted, password) {
    const builder = new flatbuffers.Builder(0);
    const privateKeyEncryptedOffset = builder.createString(privateKeyEncrypted);
    const passwordOffset = builder.createString(password);
    _decryptPrivateKeyRequest.DecryptPrivateKeyRequest.startDecryptPrivateKeyRequest(builder);
    _decryptPrivateKeyRequest.DecryptPrivateKeyRequest.addPrivateKeyEncrypted(builder, privateKeyEncryptedOffset);
    _decryptPrivateKeyRequest.DecryptPrivateKeyRequest.addPassword(builder, passwordOffset);
    const offset = _decryptPrivateKeyRequest.DecryptPrivateKeyRequest.endDecryptPrivateKeyRequest(builder);
    builder.finish(offset);
    const result = await this.call('decryptPrivateKey', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async encryptPrivateKey(privateKey, password, cipherName) {
    const builder = new flatbuffers.Builder(0);
    const privateKeyOffset = builder.createString(privateKey);
    const passwordOffset = builder.createString(password);
    _encryptPrivateKeyRequest.EncryptPrivateKeyRequest.startEncryptPrivateKeyRequest(builder);
    _encryptPrivateKeyRequest.EncryptPrivateKeyRequest.addPrivateKey(builder, privateKeyOffset);
    _encryptPrivateKeyRequest.EncryptPrivateKeyRequest.addPassword(builder, passwordOffset);
    _encryptPrivateKeyRequest.EncryptPrivateKeyRequest.addCipher(builder, cipherName);
    const offset = _encryptPrivateKeyRequest.EncryptPrivateKeyRequest.endEncryptPrivateKeyRequest(builder);
    builder.finish(offset);
    const result = await this.call('decryptPrivateKey', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async decryptOAEP(message, label, hashName, privateKey) {
    const builder = new flatbuffers.Builder(0);
    const messageOffset = builder.createString(message);
    const labelOffset = builder.createString(label);
    const privateKeyOffset = builder.createString(privateKey);
    _decryptOaeprequest.DecryptOAEPRequest.startDecryptOAEPRequest(builder);
    _decryptOaeprequest.DecryptOAEPRequest.addCiphertext(builder, messageOffset);
    _decryptOaeprequest.DecryptOAEPRequest.addLabel(builder, labelOffset);
    _decryptOaeprequest.DecryptOAEPRequest.addPrivateKey(builder, privateKeyOffset);
    _decryptOaeprequest.DecryptOAEPRequest.addHash(builder, hashName);
    const offset = _decryptOaeprequest.DecryptOAEPRequest.endDecryptOAEPRequest(builder);
    builder.finish(offset);
    const result = await this.call('decryptOAEP', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async decryptOAEPBytes(message, label, hashName, privateKey) {
    const builder = new flatbuffers.Builder(0);
    const messageOffset = builder.createByteVector(message);
    const labelOffset = builder.createString(label);
    const privateKeyOffset = builder.createString(privateKey);
    _decryptOaepbytesRequest.DecryptOAEPBytesRequest.startDecryptOAEPBytesRequest(builder);
    _decryptOaepbytesRequest.DecryptOAEPBytesRequest.addCiphertext(builder, messageOffset);
    _decryptOaepbytesRequest.DecryptOAEPBytesRequest.addLabel(builder, labelOffset);
    _decryptOaepbytesRequest.DecryptOAEPBytesRequest.addPrivateKey(builder, privateKeyOffset);
    _decryptOaepbytesRequest.DecryptOAEPBytesRequest.addHash(builder, hashName);
    const offset = _decryptOaepbytesRequest.DecryptOAEPBytesRequest.endDecryptOAEPBytesRequest(builder);
    builder.finish(offset);
    const result = await this.call('decryptOAEPBytes', builder.asUint8Array());
    return this._bytesResponse(result);
  }
  static async decryptPKCS1v15(message, privateKey) {
    const builder = new flatbuffers.Builder(0);
    const messageOffset = builder.createString(message);
    const privateKeyOffset = builder.createString(privateKey);
    _decryptPkcs1v15Request.DecryptPKCS1v15Request.startDecryptPKCS1v15Request(builder);
    _decryptPkcs1v15Request.DecryptPKCS1v15Request.addPrivateKey(builder, privateKeyOffset);
    _decryptPkcs1v15Request.DecryptPKCS1v15Request.addCiphertext(builder, messageOffset);
    const offset = _decryptPkcs1v15Request.DecryptPKCS1v15Request.endDecryptPKCS1v15Request(builder);
    builder.finish(offset);
    const result = await this.call('decryptPKCS1v15', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async decryptPKCS1v15Bytes(message, privateKey) {
    const builder = new flatbuffers.Builder(0);
    const messageOffset = builder.createByteVector(message);
    const privateKeyOffset = builder.createString(privateKey);
    _decryptPkcs1v15BytesRequest.DecryptPKCS1v15BytesRequest.startDecryptPKCS1v15BytesRequest(builder);
    _decryptPkcs1v15BytesRequest.DecryptPKCS1v15BytesRequest.addPrivateKey(builder, privateKeyOffset);
    _decryptPkcs1v15BytesRequest.DecryptPKCS1v15BytesRequest.addCiphertext(builder, messageOffset);
    const offset = _decryptPkcs1v15BytesRequest.DecryptPKCS1v15BytesRequest.endDecryptPKCS1v15BytesRequest(builder);
    builder.finish(offset);
    const result = await this.call('decryptPKCS1v15Bytes', builder.asUint8Array());
    return this._bytesResponse(result);
  }
  static async encryptOAEP(message, label, hashName, publicKey) {
    const builder = new flatbuffers.Builder(0);
    const messageOffset = builder.createString(message);
    const labelOffset = builder.createString(label);
    const publicKeyOffset = builder.createString(publicKey);
    _encryptOaeprequest.EncryptOAEPRequest.startEncryptOAEPRequest(builder);
    _encryptOaeprequest.EncryptOAEPRequest.addMessage(builder, messageOffset);
    _encryptOaeprequest.EncryptOAEPRequest.addLabel(builder, labelOffset);
    _encryptOaeprequest.EncryptOAEPRequest.addHash(builder, hashName);
    _encryptOaeprequest.EncryptOAEPRequest.addPublicKey(builder, publicKeyOffset);
    const offset = _encryptOaeprequest.EncryptOAEPRequest.endEncryptOAEPRequest(builder);
    builder.finish(offset);
    const result = await this.call('encryptOAEP', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async encryptOAEPBytes(message, label, hashName, publicKey) {
    const builder = new flatbuffers.Builder(0);
    const messageOffset = builder.createByteVector(message);
    const labelOffset = builder.createString(label);
    const publicKeyOffset = builder.createString(publicKey);
    _encryptOaepbytesRequest.EncryptOAEPBytesRequest.startEncryptOAEPBytesRequest(builder);
    _encryptOaepbytesRequest.EncryptOAEPBytesRequest.addMessage(builder, messageOffset);
    _encryptOaepbytesRequest.EncryptOAEPBytesRequest.addLabel(builder, labelOffset);
    _encryptOaepbytesRequest.EncryptOAEPBytesRequest.addHash(builder, hashName);
    _encryptOaepbytesRequest.EncryptOAEPBytesRequest.addPublicKey(builder, publicKeyOffset);
    const offset = _encryptOaepbytesRequest.EncryptOAEPBytesRequest.endEncryptOAEPBytesRequest(builder);
    builder.finish(offset);
    const result = await this.call('encryptOAEPBytes', builder.asUint8Array());
    return this._bytesResponse(result);
  }
  static async encryptPKCS1v15(message, publicKey) {
    const builder = new flatbuffers.Builder(0);
    const messageOffset = builder.createString(message);
    const publicKeyOffset = builder.createString(publicKey);
    _encryptPkcs1v15Request.EncryptPKCS1v15Request.startEncryptPKCS1v15Request(builder);
    _encryptPkcs1v15Request.EncryptPKCS1v15Request.addMessage(builder, messageOffset);
    _encryptPkcs1v15Request.EncryptPKCS1v15Request.addPublicKey(builder, publicKeyOffset);
    const offset = _encryptPkcs1v15Request.EncryptPKCS1v15Request.endEncryptPKCS1v15Request(builder);
    builder.finish(offset);
    const result = await this.call('encryptPKCS1v15', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async encryptPKCS1v15Bytes(message, publicKey) {
    const builder = new flatbuffers.Builder(0);
    const messageOffset = builder.createByteVector(message);
    const publicKeyOffset = builder.createString(publicKey);
    _encryptPkcs1v15BytesRequest.EncryptPKCS1v15BytesRequest.startEncryptPKCS1v15BytesRequest(builder);
    _encryptPkcs1v15BytesRequest.EncryptPKCS1v15BytesRequest.addMessage(builder, messageOffset);
    _encryptPkcs1v15BytesRequest.EncryptPKCS1v15BytesRequest.addPublicKey(builder, publicKeyOffset);
    const offset = _encryptPkcs1v15BytesRequest.EncryptPKCS1v15BytesRequest.endEncryptPKCS1v15BytesRequest(builder);
    builder.finish(offset);
    const result = await this.call('encryptPKCS1v15Bytes', builder.asUint8Array());
    return this._bytesResponse(result);
  }
  static async signPSS(message, hashName, saltLengthName, privateKey) {
    const builder = new flatbuffers.Builder(0);
    const messageOffset = builder.createString(message);
    const privateKeyOffset = builder.createString(privateKey);
    _signPssrequest.SignPSSRequest.startSignPSSRequest(builder);
    _signPssrequest.SignPSSRequest.addMessage(builder, messageOffset);
    _signPssrequest.SignPSSRequest.addHash(builder, hashName);
    _signPssrequest.SignPSSRequest.addSaltLength(builder, saltLengthName);
    _signPssrequest.SignPSSRequest.addPrivateKey(builder, privateKeyOffset);
    const offset = _signPssrequest.SignPSSRequest.endSignPSSRequest(builder);
    builder.finish(offset);
    const result = await this.call('signPSS', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async signPSSBytes(message, hashName, saltLengthName, privateKey) {
    const builder = new flatbuffers.Builder(0);
    const messageOffset = builder.createByteVector(message);
    const privateKeyOffset = builder.createString(privateKey);
    _signPssbytesRequest.SignPSSBytesRequest.startSignPSSBytesRequest(builder);
    _signPssbytesRequest.SignPSSBytesRequest.addMessage(builder, messageOffset);
    _signPssbytesRequest.SignPSSBytesRequest.addHash(builder, hashName);
    _signPssbytesRequest.SignPSSBytesRequest.addSaltLength(builder, saltLengthName);
    _signPssbytesRequest.SignPSSBytesRequest.addPrivateKey(builder, privateKeyOffset);
    const offset = _signPssbytesRequest.SignPSSBytesRequest.endSignPSSBytesRequest(builder);
    builder.finish(offset);
    const result = await this.call('signPSSBytes', builder.asUint8Array());
    return this._bytesResponse(result);
  }
  static async signPKCS1v15(message, hashName, privateKey) {
    const builder = new flatbuffers.Builder(0);
    const messageOffset = builder.createString(message);
    const privateKeyOffset = builder.createString(privateKey);
    _signPkcs1v15Request.SignPKCS1v15Request.startSignPKCS1v15Request(builder);
    _signPkcs1v15Request.SignPKCS1v15Request.addMessage(builder, messageOffset);
    _signPkcs1v15Request.SignPKCS1v15Request.addHash(builder, hashName);
    _signPkcs1v15Request.SignPKCS1v15Request.addPrivateKey(builder, privateKeyOffset);
    const offset = _signPkcs1v15Request.SignPKCS1v15Request.endSignPKCS1v15Request(builder);
    builder.finish(offset);
    const result = await this.call('signPKCS1v15', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async signPKCS1v15Bytes(message, hashName, privateKey) {
    const builder = new flatbuffers.Builder(0);
    const messageOffset = builder.createByteVector(message);
    const privateKeyOffset = builder.createString(privateKey);
    _signPkcs1v15BytesRequest.SignPKCS1v15BytesRequest.startSignPKCS1v15BytesRequest(builder);
    _signPkcs1v15BytesRequest.SignPKCS1v15BytesRequest.addMessage(builder, messageOffset);
    _signPkcs1v15BytesRequest.SignPKCS1v15BytesRequest.addHash(builder, hashName);
    _signPkcs1v15BytesRequest.SignPKCS1v15BytesRequest.addPrivateKey(builder, privateKeyOffset);
    const offset = _signPkcs1v15BytesRequest.SignPKCS1v15BytesRequest.endSignPKCS1v15BytesRequest(builder);
    builder.finish(offset);
    const result = await this.call('signPKCS1v15Bytes', builder.asUint8Array());
    return this._bytesResponse(result);
  }
  static async verifyPSS(signature, message, hashName, saltLengthName, publicKey) {
    const builder = new flatbuffers.Builder(0);
    const signatureOffset = builder.createString(signature);
    const messageOffset = builder.createString(message);
    const publicKeyOffset = builder.createString(publicKey);
    _verifyPssrequest.VerifyPSSRequest.startVerifyPSSRequest(builder);
    _verifyPssrequest.VerifyPSSRequest.addSignature(builder, signatureOffset);
    _verifyPssrequest.VerifyPSSRequest.addMessage(builder, messageOffset);
    _verifyPssrequest.VerifyPSSRequest.addHash(builder, hashName);
    _verifyPssrequest.VerifyPSSRequest.addSaltLength(builder, saltLengthName);
    _verifyPssrequest.VerifyPSSRequest.addPublicKey(builder, publicKeyOffset);
    const offset = _verifyPssrequest.VerifyPSSRequest.endVerifyPSSRequest(builder);
    builder.finish(offset);
    const result = await this.call('verifyPSS', builder.asUint8Array());
    return this._boolResponse(result);
  }
  static async verifyPSSBytes(signature, message, hashName, saltLengthName, publicKey) {
    const builder = new flatbuffers.Builder(0);
    const signatureOffset = builder.createByteVector(signature);
    const messageOffset = builder.createByteVector(message);
    const publicKeyOffset = builder.createString(publicKey);
    _verifyPssbytesRequest.VerifyPSSBytesRequest.startVerifyPSSBytesRequest(builder);
    _verifyPssbytesRequest.VerifyPSSBytesRequest.addSignature(builder, signatureOffset);
    _verifyPssbytesRequest.VerifyPSSBytesRequest.addMessage(builder, messageOffset);
    _verifyPssbytesRequest.VerifyPSSBytesRequest.addHash(builder, hashName);
    _verifyPssbytesRequest.VerifyPSSBytesRequest.addSaltLength(builder, saltLengthName);
    _verifyPssbytesRequest.VerifyPSSBytesRequest.addPublicKey(builder, publicKeyOffset);
    const offset = _verifyPssbytesRequest.VerifyPSSBytesRequest.endVerifyPSSBytesRequest(builder);
    builder.finish(offset);
    const result = await this.call('verifyPSSBytes', builder.asUint8Array());
    return this._boolResponse(result);
  }
  static async verifyPKCS1v15(signature, message, hashName, publicKey) {
    const builder = new flatbuffers.Builder(0);
    const signatureOffset = builder.createString(signature);
    const messageOffset = builder.createString(message);
    const publicKeyOffset = builder.createString(publicKey);
    _verifyPkcs1v15Request.VerifyPKCS1v15Request.startVerifyPKCS1v15Request(builder);
    _verifyPkcs1v15Request.VerifyPKCS1v15Request.addSignature(builder, signatureOffset);
    _verifyPkcs1v15Request.VerifyPKCS1v15Request.addMessage(builder, messageOffset);
    _verifyPkcs1v15Request.VerifyPKCS1v15Request.addHash(builder, hashName);
    _verifyPkcs1v15Request.VerifyPKCS1v15Request.addPublicKey(builder, publicKeyOffset);
    const offset = _verifyPkcs1v15Request.VerifyPKCS1v15Request.endVerifyPKCS1v15Request(builder);
    builder.finish(offset);
    const result = await this.call('verifyPKCS1v15', builder.asUint8Array());
    return this._boolResponse(result);
  }
  static async verifyPKCS1v15Bytes(signature, message, hashName, publicKey) {
    const builder = new flatbuffers.Builder(0);
    const signatureOffset = builder.createByteVector(signature);
    const messageOffset = builder.createByteVector(message);
    const publicKeyOffset = builder.createString(publicKey);
    _verifyPkcs1v15BytesRequest.VerifyPKCS1v15BytesRequest.startVerifyPKCS1v15BytesRequest(builder);
    _verifyPkcs1v15BytesRequest.VerifyPKCS1v15BytesRequest.addSignature(builder, signatureOffset);
    _verifyPkcs1v15BytesRequest.VerifyPKCS1v15BytesRequest.addMessage(builder, messageOffset);
    _verifyPkcs1v15BytesRequest.VerifyPKCS1v15BytesRequest.addHash(builder, hashName);
    _verifyPkcs1v15BytesRequest.VerifyPKCS1v15BytesRequest.addPublicKey(builder, publicKeyOffset);
    const offset = _verifyPkcs1v15BytesRequest.VerifyPKCS1v15BytesRequest.endVerifyPKCS1v15BytesRequest(builder);
    builder.finish(offset);
    const result = await this.call('verifyPKCS1v15Bytes', builder.asUint8Array());
    return this._boolResponse(result);
  }
  static async hash(message, name) {
    const builder = new flatbuffers.Builder(0);
    const messageOffset = builder.createString(message);
    _hashRequest.HashRequest.startHashRequest(builder);
    _hashRequest.HashRequest.addMessage(builder, messageOffset);
    _hashRequest.HashRequest.addHash(builder, name);
    const offset = _hashRequest.HashRequest.endHashRequest(builder);
    builder.finish(offset);
    const result = await this.call('hash', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async base64(message) {
    const builder = new flatbuffers.Builder(0);
    const messageOffset = builder.createString(message);
    _base64Request.Base64Request.startBase64Request(builder);
    _base64Request.Base64Request.addMessage(builder, messageOffset);
    const offset = _base64Request.Base64Request.endBase64Request(builder);
    builder.finish(offset);
    const result = await this.call('base64', builder.asUint8Array());
    return this._stringResponse(result);
  }
  static async generate(bits) {
    const builder = new flatbuffers.Builder(0);
    _generateRequest.GenerateRequest.startGenerateRequest(builder);
    _generateRequest.GenerateRequest.addNBits(builder, bits);
    const offset = _generateRequest.GenerateRequest.endGenerateRequest(builder);
    builder.finish(offset);
    const result = await this.call('generate', builder.asUint8Array());
    return this._keyPairResponse(result);
  }
  static async call(name, bytes) {
    try {
      if (this.useJSI && typeof global.FastRSACallPromise === 'function') {
        const buff = bytes.buffer.slice(bytes.byteOffset, bytes.byteLength + bytes.byteOffset);
        const result = global.FastRSACallSync(name, buff);
        const rawResponse = new Uint8Array(result, 0, result.byteLength);
        return new flatbuffers.ByteBuffer(rawResponse);
      } else {
        const result = await FastRSANativeModules.call(name, Array.from(bytes));
        const rawResponse = new Uint8Array(result);
        return new flatbuffers.ByteBuffer(rawResponse);
      }
    } catch (e) {
      throw new RSAError(`BridgeCall failed: ${e}`);
    }
  }
  static _bytesResponse(result) {
    const response = _bytesResponse.BytesResponse.getRootAsBytesResponse(result);
    const error = response.error();
    if (error) {
      throw new RSAError('stringResponse: ' + error);
    }
    return response.outputArray() || Uint8Array.from([]);
  }
  static _stringResponse(result) {
    const response = _stringResponse.StringResponse.getRootAsStringResponse(result);
    const error = response.error();
    if (error) {
      throw new RSAError('stringResponse: ' + error);
    }
    return response.output() || '';
  }
  static _boolResponse(result) {
    const response = _boolResponse.BoolResponse.getRootAsBoolResponse(result);
    const error = response.error();
    if (error) {
      throw new RSAError('boolResponse: ' + error);
    }
    return response.output();
  }
  static _keyPairResponse(result) {
    const response = _keyPairResponse.KeyPairResponse.getRootAsKeyPairResponse(result);
    const error = response.error();
    if (error) {
      throw new RSAError('keyPairResponse: ' + error);
    }
    const output = response.output();
    if (!output) {
      throw new RSAError('empty output');
    }
    return {
      privateKey: output.privateKey() || '',
      publicKey: output.publicKey() || ''
    };
  }
  static _pkcs12KeyPairResponse(result) {
    const response = _pkcs12KeyPairResponse.PKCS12KeyPairResponse.getRootAsPKCS12KeyPairResponse(result);
    const error = response.error();
    if (error) {
      throw new RSAError('pkcs12KeyPairResponse: ' + error);
    }
    const output = response.output();
    if (!output) {
      throw new RSAError('empty output');
    }
    return {
      privateKey: output.privateKey() || '',
      publicKey: output.publicKey() || '',
      certificate: output.certificate() || ''
    };
  }
}
exports.default = RSA;
//# sourceMappingURL=index.js.map