"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _reactNative = require("react-native");
const FastRSANativeModules = _reactNative.NativeModules.FastRsa;
const isDebuggingEnabled = typeof atob !== 'undefined' && typeof HermesInternal === 'undefined';
typeof global.FastRSADecodeText === 'undefined' && !isDebuggingEnabled && FastRSANativeModules.install();
class TextDecoder {
  constructor() {
    let label = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'utf-8';
    let options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    this.encoding = label.toLowerCase();
    this.fatal = options.fatal ?? false;
    this.ignoreBOM = options.ignoreBOM ?? false;
  }
  decode(input) {
    let options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    if (!input) {
      return '';
    }
    if (typeof global.FastRSADecodeText === 'function') {
      const ress = global.FastRSADecodeText(input, this.encoding, this.fatal, this.ignoreBOM, options.stream ?? false);
      return ress;
    }
    return FastRSANativeModules.decodeText(Array.from(input), this.encoding, this.fatal, this.ignoreBOM, options.stream ?? false);
  }
}
exports.default = TextDecoder;
//# sourceMappingURL=text-decoder.js.map