"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _reactNative = require("react-native");
const FastRSANativeModules = _reactNative.NativeModules.FastRsa;
const isDebuggingEnabled = typeof atob !== 'undefined' && typeof HermesInternal === 'undefined';
typeof global.FastRSAEncodeText === 'undefined' && !isDebuggingEnabled && FastRSANativeModules.install();
class TextEncoder {
  get encoding() {
    return 'utf-8';
  }
  encode() {
    let input = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    if (typeof global.FastRSAEncodeText === 'function') {
      const result = global.FastRSAEncodeText(input, 'utf-8');
      return new Uint8Array(result);
    }
    const result = FastRSANativeModules.encodeText(input, 'utf-8');
    return new Uint8Array(result);
  }
}
exports.default = TextEncoder;
//# sourceMappingURL=text-encoder.js.map