import * as flatbuffers from 'flatbuffers';
import { Hash } from '../model/hash';
import { SaltLength } from '../model/salt-length';
export declare class SignPSSRequest {
    bb: flatbuffers.ByteBuffer | null;
    bb_pos: number;
    __init(i: number, bb: flatbuffers.ByteBuffer): SignPSSRequest;
    static getRootAsSignPSSRequest(bb: flatbuffers.ByteBuffer, obj?: SignPSSRequest): SignPSSRequest;
    static getSizePrefixedRootAsSignPSSRequest(bb: flatbuffers.ByteBuffer, obj?: SignPSSRequest): SignPSSRequest;
    message(): string | null;
    message(optionalEncoding: flatbuffers.Encoding): string | Uint8Array | null;
    hash(): Hash;
    mutate_hash(value: Hash): boolean;
    saltLength(): SaltLength;
    mutate_salt_length(value: SaltLength): boolean;
    privateKey(): string | null;
    privateKey(optionalEncoding: flatbuffers.Encoding): string | Uint8Array | null;
    static startSignPSSRequest(builder: flatbuffers.Builder): void;
    static addMessage(builder: flatbuffers.Builder, messageOffset: flatbuffers.Offset): void;
    static addHash(builder: flatbuffers.Builder, hash: Hash): void;
    static addSaltLength(builder: flatbuffers.Builder, saltLength: SaltLength): void;
    static addPrivateKey(builder: flatbuffers.Builder, privateKeyOffset: flatbuffers.Offset): void;
    static endSignPSSRequest(builder: flatbuffers.Builder): flatbuffers.Offset;
    static createSignPSSRequest(builder: flatbuffers.Builder, messageOffset: flatbuffers.Offset, hash: Hash, saltLength: SaltLength, privateKeyOffset: flatbuffers.Offset): flatbuffers.Offset;
}
//# sourceMappingURL=sign-pssrequest.d.ts.map