import * as flatbuffers from 'flatbuffers';
import { Hash } from '../model/hash';
import { SaltLength } from '../model/salt-length';
export declare class VerifyPSSBytesRequest {
    bb: flatbuffers.ByteBuffer | null;
    bb_pos: number;
    __init(i: number, bb: flatbuffers.ByteBuffer): VerifyPSSBytesRequest;
    static getRootAsVerifyPSSBytesRequest(bb: flatbuffers.ByteBuffer, obj?: VerifyPSSBytesRequest): VerifyPSSBytesRequest;
    static getSizePrefixedRootAsVerifyPSSBytesRequest(bb: flatbuffers.ByteBuffer, obj?: VerifyPSSBytesRequest): VerifyPSSBytesRequest;
    signature(index: number): number | null;
    signatureLength(): number;
    signatureArray(): Uint8Array | null;
    message(index: number): number | null;
    messageLength(): number;
    messageArray(): Uint8Array | null;
    hash(): Hash;
    mutate_hash(value: Hash): boolean;
    saltLength(): SaltLength;
    mutate_salt_length(value: SaltLength): boolean;
    publicKey(): string | null;
    publicKey(optionalEncoding: flatbuffers.Encoding): string | Uint8Array | null;
    static startVerifyPSSBytesRequest(builder: flatbuffers.Builder): void;
    static addSignature(builder: flatbuffers.Builder, signatureOffset: flatbuffers.Offset): void;
    static createSignatureVector(builder: flatbuffers.Builder, data: number[] | Uint8Array): flatbuffers.Offset;
    static startSignatureVector(builder: flatbuffers.Builder, numElems: number): void;
    static addMessage(builder: flatbuffers.Builder, messageOffset: flatbuffers.Offset): void;
    static createMessageVector(builder: flatbuffers.Builder, data: number[] | Uint8Array): flatbuffers.Offset;
    static startMessageVector(builder: flatbuffers.Builder, numElems: number): void;
    static addHash(builder: flatbuffers.Builder, hash: Hash): void;
    static addSaltLength(builder: flatbuffers.Builder, saltLength: SaltLength): void;
    static addPublicKey(builder: flatbuffers.Builder, publicKeyOffset: flatbuffers.Offset): void;
    static endVerifyPSSBytesRequest(builder: flatbuffers.Builder): flatbuffers.Offset;
    static createVerifyPSSBytesRequest(builder: flatbuffers.Builder, signatureOffset: flatbuffers.Offset, messageOffset: flatbuffers.Offset, hash: Hash, saltLength: SaltLength, publicKeyOffset: flatbuffers.Offset): flatbuffers.Offset;
}
//# sourceMappingURL=verify-pssbytes-request.d.ts.map